#ifndef PD8255_H_INCLUDED
#define PD8255_H_INCLUDED

#include "pc6001v.h"
#include "device.h"

#include "p6device.h"


////////////////////////////////////////////////////////////////
// 饹
////////////////////////////////////////////////////////////////
class D8255 {
protected:
	BYTE PortA;						// ݡA
	BYTE PortB;						// ݡB
	BYTE PortC;						// ݡC
	
	BYTE PortAbuf;					// ݡAХåե(8049ϤŪ˥å)
	
	int ModeA;						// 롼A⡼
	int ModeB;						// 롼B⡼
	
	BOOL PortAdir;					// ݡA          TRUE:(ɤ) FALSE:()
	BOOL PortBdir;					// ݡB          TRUE:(ɤ) FALSE:()
	BOOL PortC1dir;					// ݡC(bit0-3)  TRUE:(ɤ) FALSE:()
	BOOL PortC2dir;					// ݡC(bit4-7)  TRUE:(ɤ) FALSE:()
	
	BOOL HSINT0;					// INT0
	BOOL HSWINT0;					// WINT0
	BOOL HSRINT0;					// RINT0
	BOOL HSSTB0;					// STB0
	BOOL HSIBF0;					// IBF0
	BOOL HSDAK0;					// DAK0
	BOOL HSOBF0;					// OBF0
	
	BOOL RIE0;						// RIE0
	BOOL WIE0;						// WIE0
	
	// Ͻؿ
	virtual void JobWriteA( BYTE ){}
	virtual void JobWriteB( BYTE ){}
	virtual void JobWriteC1( BYTE ){}	// 
	virtual void JobWriteC2( BYTE ){}	// 
	virtual void JobWriteD( BYTE ){}	// ӥåȥå/ꥻåȤΤ
	virtual void JobReadA(){}
	virtual void JobReadB(){}
	virtual void JobReadC(){}
	
	void SetMode( BYTE );			// ⡼
	
public:
	D8255();						// 󥹥ȥ饯
	virtual ~D8255();				// ǥȥ饯
	
	BOOL Init( void );				// 
	
	void Reset();					// ꥻå
	
	// ϴؿ
	void WriteA( BYTE );
	void WriteB( BYTE );
	void WriteC( BYTE );
	void WriteD( BYTE );			// ȥݡȽ
	BYTE ReadA();
	BYTE ReadB();
	BYTE ReadC();
	
	// ⡼2ϥɥ
	void WriteAE( BYTE );			// PartA 饤(¦)
	BYTE ReadAE();					// PartA ꡼(¦)
	BOOL GetIBF();					// IBF
	BOOL GetOBF();					// OBF
};


class PIO6 : public P6DEVICE, public Device, public D8255, public IDoko {
private:
	// Ͻؿ
	void JobWriteA( BYTE );
	void JobWriteC1( BYTE );
	void JobWriteD( BYTE );
	
	// ǥХ
	static const Descriptor descriptor;
	static const InFuncPtr  indef[];
	static const OutFuncPtr outdef[];
	const Descriptor* GetDesc() const { return &descriptor; }
	
	// I/Oؿ
	inline void Out90H( int, BYTE data ){ WriteA( data ); }
	inline void Out91H( int, BYTE data ){ WriteB( data ); }
	inline void Out92H( int, BYTE data ){ WriteC( data ); }
	inline void Out93H( int, BYTE data ){ WriteD( data ); }
	inline BYTE In90H( int ){ return ReadA(); }
	inline BYTE In92H( int ){ return ReadC(); }
	inline BYTE In93H( int ){ return 0xff; }
	
	inline void OutPBH( int, BYTE data ){ WriteAE( data ); }
	inline BYTE InPBH( int ){ return ReadAE(); }
	inline BYTE InIBF( int ){ return GetIBF() ? 1 : 0; }
	inline BYTE InOBF( int ){ return GetOBF() ? 1 : 0; }
	
public:
	PIO6( VM6 *, const ID& );		// 󥹥ȥ饯
	~PIO6();						// ǥȥ饯
	
	// ǥХID
	enum IDOut{ out90H=0, out91H, out92H, out93H, outPBH         };
	enum IDIn {  in90H=0,  in92H,          in93H,  inPBH,  inIBF,  inOBF };
	
	// ------------------------------------------
	BOOL DokoSave( cIni * );	// ɤǤSAVE
	BOOL DokoLoad( cIni * );	// ɤǤLOAD
	// ------------------------------------------
};

#endif	// PD8255_H_INCLUDED
