#include "schedule.h"
#include "mc6847.h"


#define WRUPDATE	(1000)	/* ®ٹֳ(ms) */


////////////////////////////////////////////////////////////////
// 󥹥ȥ饯
////////////////////////////////////////////////////////////////
cSche::cSche( void )
{
	for( int i=0; i<MAXEVENT; i++ ){
		ev[i].device = NULL;
		ev[i].Active = FALSE;
	}
	MasterClock = CPU_CLOCK;
	
	NextEvent  = -1;
	SaveCloclk = 0;
	
	WRClock    = 0;
	WRClockTmp = 0;
}


////////////////////////////////////////////////////////////////
// ǥȥ饯
////////////////////////////////////////////////////////////////
cSche::~cSche( void ){}


////////////////////////////////////////////////////////////////
// ٥ȸ
//
// :	dev			٥ȥǥХ֥ȥݥ
//			id			٥ID
// :	evinfo *	٥Ⱦݥ(¸ߤʤNULL)
////////////////////////////////////////////////////////////////
cSche::evinfo *cSche::Find( P6DEVENT *dev, int id )
{
	for( int i=0; i<MAXEVENT; i++ )
		if( ev[i].device == dev && ev[i].id == id ) return &ev[i];
	
	return NULL;
}


////////////////////////////////////////////////////////////////
// ޥå
//
// :	clock	ޥå
// :	ʤ
////////////////////////////////////////////////////////////////
void cSche::SetMasterClock( int clock )
{
	MasterClock = clock;
	for( int i=0; i<MAXEVENT; i++ )
		if( ev[i].device && ev[i].nps > 0 && ev[i].Period > 0 ){
			ev[i].Period = (int)((double)clock / ev[i].nps);
			if( ev[i].Period < 1 ) ev[i].Period = 1;
		}

}


////////////////////////////////////////////////////////////////
// ٥ɲ
//
// :	dev		٥ȥǥХ֥ȥݥ
//			id		٥ID
//			hz		٥ȯȿ
//			loop	롼׻ TRUE:롼 FALSE:󥿥
//			flag	٥ȥ
//				bit0  : ֤ؼ 0:󥿥 1:롼
//				bit2,3,4: ñ 000:Hz 001:us 010:ms 100:CPUơȿ
// :	BOOL	TRUE: FALSE:
////////////////////////////////////////////////////////////////
BOOL cSche::Add( P6DEVENT *dev, int id, double hz, int flag )
{
	// ϿѤߤξϰöƺϿ
	evinfo *e = Find( dev, id );
	if( e ) Del( e->device, e->id );
	
	for( int i=0; i<MAXEVENT; i++ ){
		if( !ev[i].device ){
			ev[i].device = dev;
			ev[i].id     = id;
			ev[i].Active = TRUE;
			
			// ٥ȯȿ
			switch( flag&(EV_US|EV_MS|EV_STATE) ){
			case EV_US:		// usǻؼ
				ev[i].nps    = (double)1000000 / hz;
				ev[i].Clock  = (int)((double)MasterClock / ev[i].nps);
				break;
			case EV_MS:		// msǻؼ
				ev[i].nps    = (double)1000 / hz;
				ev[i].Clock  = (int)((double)MasterClock / ev[i].nps);
				break;
			case EV_STATE:	// CPUơȿǻؼ
				ev[i].nps    = (double)MasterClock / hz;
				ev[i].Clock  = (int)hz;
				break;
			default:		// Hzǻؼ
				ev[i].nps    = hz;
				ev[i].Clock  = (int)((double)MasterClock / hz);
			}
			
			// 
			if( flag&EV_LOOP ){	// 롼ץ٥
				ev[i].Period = ev[i].Clock;
				if( ev[i].Period < 1 ) ev[i].Period = 1;
			}else				// 󥿥।٥
				ev[i].Period = 0;
			
			// Υ٥ȤޤǤΥå
			if( NextEvent < 0 ) NextEvent = ev[i].Clock;
			else                NextEvent = min( NextEvent, ev[i].Clock );
			
			return TRUE;
		}
	}
	return FALSE;
}


////////////////////////////////////////////////////////////////
// ٥Ⱥ
//
// :	dev		٥ȥǥХ֥ȥݥ
//			id		٥ID
// :	BOOL	TRUE: FALSE:
////////////////////////////////////////////////////////////////
BOOL cSche::Del( P6DEVENT *dev, int id )
{
	evinfo *e = Find( dev, id );
	if( e ){
		e->device = NULL;
		e->Active = FALSE;
		return TRUE;
	}else
		return FALSE;
}


////////////////////////////////////////////////////////////////
// ٥ȯȿ
//
// :	dev		٥ȥǥХ֥ȥݥ
//			id		٥ID
//			hz		٥ȯȿ
// :	BOOL	TRUE: FALSE:
////////////////////////////////////////////////////////////////
BOOL cSche::SetHz( P6DEVENT *dev, int id, double hz )
{
	evinfo *e = Find( dev, id );
	if( e ){
		e->nps    = hz;
		e->Period = (int)((double)MasterClock / hz);
		return TRUE;
	}else
		return FALSE;
}


////////////////////////////////////////////////////////////////
// ٥ȹ
//
// :	clk		ʤ륯å
// :	ʤ
////////////////////////////////////////////////////////////////
void cSche::Update( int clk )
{
	// åί
	SaveCloclk += clk;	// Υ٥ȯ
	WRClockTmp += clk;	// ¹®ٷ׻
	
	// Υ٥ȯåãƤʤä
	//  clk=0 ξϹԤ
	if( NextEvent > SaveCloclk && clk ) return;
	NextEvent = -1;
	
	int cnt;
	do{
		cnt = 0;
		for( int i=0; i<MAXEVENT; i++ ){
			// ͭʥ٥?
			if( ev[i].Active ){
				ev[i].Clock -= SaveCloclk;
				// ֳ֤Ĺʣȯǽ
				// ȤꤢƤʤޤǷ֤äƤȤǤΤ?
				if( ev[i].Clock <= 0 ){
					// ٥ȥХå¹
					ev[i].device->EventCallback( ev[i].id, ev[i].Clock );
					
					if( ev[i].Period > 0 ){	// 롼ץ٥
						ev[i].Clock += ev[i].Period;
						if( ev[i].Clock <= 0 ) cnt++;	// Υ٥ȤȯƤ饫
					}else{					// 󥿥।٥
						Del( ev[i].device, ev[i].id );
						break;
					}
				}
				// Υ٥ȤޤǤΥå
				if( NextEvent < 0 ) NextEvent = ev[i].Clock;
				else                NextEvent = min( NextEvent, ev[i].Clock );
			}
		}
		SaveCloclk = 0;
	}while( cnt > 0 );
}


////////////////////////////////////////////////////////////////
// ꥤ٥ȤꥻåȤ
//
// :	dev		٥ȥǥХ֥ȥݥ
//			id		٥ID
// :	ʤ
////////////////////////////////////////////////////////////////
void cSche::Reset( P6DEVENT *dev, int id )
{
	evinfo *e = Find( dev, id );
	if( e ){
		// ίåʬθ
		e->Clock = e->Period + SaveCloclk;
	}
}


////////////////////////////////////////////////////////////////
// ٥ȯޤǤλĤꥯå
//
// :	dev		٥ȥǥХ֥ȥݥ
//			id		٥ID
// :	int		Ĥꥹơȿ(ID̵ʤ0)
////////////////////////////////////////////////////////////////
int cSche::Rest( P6DEVENT *dev, int id )
{
	evinfo *e = Find( dev, id );
	if( e ) return e->Clock;
	else    return 0;
}


////////////////////////////////////////////////////////////////
// ٥ȤοʹΨ
//
// :	dev		٥ȥǥХ֥ȥݥ
//			id		٥ID
// :	double	٥ȿʹΨ(1.0100%)
////////////////////////////////////////////////////////////////
double cSche::Scale( P6DEVENT *dev, int id )
{
	evinfo *e = Find( dev, id );
	// ٥Ȥ¸ߤ1ΥåꤵƤ?
	if( e && e->Period > 0 ){
		// ίåθ
		double sc = (double)( (double)( e->Period - e->Clock + SaveCloclk ) / (double)e->Period );
		return min( max( 0.0, sc ), 1.0 );
	}else
		return 0;
}


////////////////////////////////////////////////////////////////
// ٥Ⱦ
//
// :	evinfo *	٥Ⱦ¤ΤؤΥݥ(device,id 򥻥åȤƤ)
// :	BOOL		TRUE: FALSE:
////////////////////////////////////////////////////////////////
BOOL cSche::GetEvinfo( evinfo *info )
{
	if( !info ) return FALSE;
	
	evinfo *e = Find( info->device, info->id );
	if( e ){
		info->Active = e->Active;
		info->Period = e->Period;
		info->Clock  = e->Clock;
		info->nps    = e->nps;
		return TRUE;
	}
	return FALSE;
}


////////////////////////////////////////////////////////////////
// ٥Ⱦ
//
// :	evinfo *	٥Ⱦ¤ΤؤΥݥ
// :	BOOL		TRUE: FALSE:
////////////////////////////////////////////////////////////////
BOOL cSche::SetEvinfo( evinfo *info )
{
	if( !info ) return FALSE;
	
	// ̵Ѥɲ
	if( !Add( info->device, info->id, 1, EV_HZ ) ) return FALSE;
	
	evinfo *e = Find( info->device, info->id );
	if( e ){
		e->Active = info->Active;
		e->Period = info->Period;
		e->Clock  = info->Clock;
		e->nps    = info->nps;
		return TRUE;
	}
	return FALSE;
}






////////////////////////////////////////////////////////////////
// 󥹥ȥ饯
////////////////////////////////////////////////////////////////
SCH6::SCH6( VM6 *vm, const P6ID& id ) : P6DEVICE(vm,id)
{
	CpuClock   = CPU_CLOCK;
	WaitEnable = TRUE;
	VSYNC      = FALSE;
	
	// ޥե
	WaitSem = SDL_CreateSemaphore( 0 );
}


////////////////////////////////////////////////////////////////
// ǥȥ饯
////////////////////////////////////////////////////////////////
SCH6::~SCH6( void )
{
	// ư
	Stop();
	
	// ޥե
	if( WaitSem ) SDL_DestroySemaphore( WaitSem );

}


////////////////////////////////////////////////////////////////
// åɴؿ(С饤)
//   SDL_Delay()٤˺ΤǤäø
//   49.7ʾϢ³ưOSǤԶ礬뤱ɡǤ
//
// :	inst	ʬȤΥ֥ȥݥ
// :	ʤ
////////////////////////////////////////////////////////////////
void SCH6::OnThread( void *inst )
{
	SCH6 *ti;
	int Vint[VSYNC_HZ];
	int VintCnt = 0;
	DWORD now,last;
	
	EnableScrUpdate = 0;
	
	ti = (SCH6 *)inst;	// ʬȤΥ֥ȥݥ󥿼
	
	// 1ô֤Υ󥿡Х
	for( int i=0; i<VSYNC_HZ; i++ ) Vint[i] = (int)( 1000 / VSYNC_HZ );
	int Vrem = 1000 - (int)( 1000 / VSYNC_HZ ) * VSYNC_HZ;
	for( int i=0; i<Vrem; i++ ) Vint[(int)(VSYNC_HZ * i / Vrem)]++;
	
	// ǽԤ֤
	now  = SDL_GetTicks();
	last = now;
	DWORD NextWait = now + Vint[VintCnt++];
	
	while( !this->SThread::IsCancel() ){
		now = SDL_GetTicks();
		if( now >= NextWait ){
			NextWait += Vint[VintCnt++];
			if( VintCnt >= VSYNC_HZ ) VintCnt -= VSYNC_HZ;
			ti->WaitReset();
		}else
			SDL_Delay( 1 );
		
		if( now - last >= WRUPDATE ){
			WRClock     = WRClockTmp;
			WRClockTmp  = 0;
			last       += WRUPDATE;
		}
	}
}


////////////////////////////////////////////////////////////////
// ư
//
// :	ʤ
// :	ʤ
////////////////////////////////////////////////////////////////
BOOL SCH6::Start( void )
{
	// å
	if( !this->SThread::BeginThread( this ) ) return FALSE;
	this->SThread::Start();
	return TRUE;
}


////////////////////////////////////////////////////////////////
// ư
//
// :	ʤ
// :	ʤ
////////////////////////////////////////////////////////////////
void SCH6::Stop( void )
{
	this->SThread::Cancel();	// åɽλե饰ΩƤ
	this->SThread::Waiting();	// åɽλޤԤ
}


////////////////////////////////////////////////////////////////
// Waitͭե饰
//
// :	ʤ
// :	ͭ:TRUE ̵:FALSE
////////////////////////////////////////////////////////////////
BOOL SCH6::GetWaitEnable( void )
{
	return WaitEnable;
}


////////////////////////////////////////////////////////////////
// Waitͭե饰
//
// :	Waitͭե饰 ͭ:TRUE ̵:FALSE
// :	ʤ
////////////////////////////////////////////////////////////////
void SCH6::SetWaitEnable( BOOL we )
{
	WaitEnable = we;
}


////////////////////////////////////////////////////////////////
// VSYNC Wait
//
// :	ʤ
// :	ʤ
////////////////////////////////////////////////////////////////
void SCH6::VWait( void )
{
	if( vm->IsWaitEnable() ) SDL_SemWait( WaitSem );
	VSYNC = FALSE;
}


////////////////////////////////////////////////////////////////
// Wait
//
// :	ʤ
// :	ʤ
////////////////////////////////////////////////////////////////
void SCH6::WaitReset( void )
{
	if( !SDL_SemValue( WaitSem ) ) SDL_SemPost( WaitSem );
	
	// ̹ե饰ΩƤ
	EnableScrUpdate++;
}


////////////////////////////////////////////////////////////////
// 
//
// :	clock	CPUå(Hz)
// :	BOOL	TRUE: FALSE:
////////////////////////////////////////////////////////////////
BOOL SCH6::Init( int clock )
{
	// ޥեå
	if( !WaitSem ) return FALSE;
	
	// CPUå
	CpuClock = clock;
	
	return TRUE;
}


////////////////////////////////////////////////////////////////
// ** ɻȤʤʤޤ **
// ̤ɽ֤˱CPUơȿ׻
//
// :	ʤ
// :	ʤ
////////////////////////////////////////////////////////////////
// PC-6001mk2SRΥޥ˥奢뤫 (ʤSR? ޤ޼긵ˤ줷ʤä)

// ɽȿ
// ʿ 15.70kHz(63.70usec)
// ľ 59.92 Hz(16.69msec)

// ʿߥ (ñ:usec)
// ɽ⡼ ʿ Хåݡ ɽ եȥݡ  
// 32ʸ		4.87	13.74		35.76		9.33		63.70
// 40,80ʸ	4.87	 9.27		44.69		4.86		63.69

// ľߥ (ñ:msec)
// ɽ⡼ ľ Хåݡ ɽ եȥݡ  
// 192H			0.25	 2.49		12.23		1.72		16.69
// 200H			0.25	 2.23		12.74		1.47		16.69
// 204H			0.25	 2.11		12.99		1.34		16.69

// ɥåȥå,饤֤
// ʿߥ
// ɽ⡼ ʿ Хåݡ ɽ եȥݡ  
// 32ʸ		34			98			256		67			455
// 40,80ʸ	34	 		66			320		35			455

// ľߥ
// ɽ⡼ ľ Хåݡ ɽ եȥݡ  
// 192H			3			34			192		33			262
// 200H			3		 	30			200		29			262
// 204H			4(?)		33			204		21			262


// ޤȤȤʴ
// ʿȡ   455 Clk (ɥåȥå 7.16MHz? 3.58MHzξå?)
// ʿɽ       256 320 Clk
// ʿɽ     199 135 Clk
// ľȡ饤 262 Line
// ľɽ饤     192 200 204 Line
// ľɽ饤    70  62  58 Line

// [ɽ]ΤCPUߤȹͤȡƯΨϤʴ
// ǤSRϤʤ˻ߤޤʤ餷
// N60   : 58.769% ( 199*192 + 455*70 ) / ( 262*455 )
// N60m  : 46.313% ( 135*200 + 455*62 ) / ( 262*455 )
// N66SR : 45.239% ( 135*204 + 455*58 ) / ( 262*455 )

// CPUåǹͤ
// CPUå/s      3993600
// CPUå/VSYNC    66560 (VSYNC:60HzȤ)
// CPUå/1Line     1109 (66560/262)
//   ư:/1Line  486:623 331:778
// CPUå/VBlank  146368  155240

/*
#define	Ref1	(double)( (double)( 199*192 + 455*70 ) / (double)( 262*455 ) )
#define	Ref2	(double)( (double)( 135*200 + 455*62 ) / (double)( 262*455 ) )

void SCH6::CalcCpuState( void )
{
	BOOL disp = vm->vdg->GetCrtDisp();
	BOOL win  = vm->vdg->GetWinSize();
	
	// 1äΥơȿ
	int CpuState;
	if( disp ) CpuState = (int)( (win ? Ref1 : Ref2) * (double)CpuClock );
	else       CpuState = CpuClock;

CpuState = CpuClock;
	
	// Τޤޤ®ΤŬĴ
//	CpuState = CpuState * 86 / 100;
	
	// ޥå
	cSche::SetMasterClock( CpuState );
}
*/


////////////////////////////////////////////////////////////////
// ¹®
//
// :	ʤ
// :	int		¹®(%)(ܤ100)
////////////////////////////////////////////////////////////////
int SCH6::GetRatio( void )
{
	return (int)(double)( WRClock * 100.0 / MasterClock * 1000.0 / WRUPDATE + 0.5 );
}


////////////////////////////////////////////////////////////////
// ̹ޤ?
//
// :	ʤ
// :	BOOL		TRUE: FALSE:ʤ
////////////////////////////////////////////////////////////////
BOOL SCH6::IsScreenUpdate( void )
{
	if( EnableScrUpdate ){
		EnableScrUpdate--;
		return TRUE;
	}
	return FALSE;
}


////////////////////////////////////////////////////////////////
// ɤǤSAVE
//
// :	Ini		INI֥ȥݥ
// :	BOOL	TRUE: FALSE:
////////////////////////////////////////////////////////////////
BOOL SCH6::DokoSave( cIni *Ini )
{
	if( !Ini ) return FALSE;
	
	Ini->PutEntry( "SCHEDULE", NULL, "MasterClock",	"%d",	MasterClock );
	Ini->PutEntry( "SCHEDULE", NULL, "CpuClock",	"%d",	CpuClock );
	Ini->PutEntry( "SCHEDULE", NULL, "VSYNC",		"%s",	VSYNC ? "Yes" : "No" );
	Ini->PutEntry( "SCHEDULE", NULL, "NextEvent",	"%d",	NextEvent );
	Ini->PutEntry( "SCHEDULE", NULL, "SaveCloclk",	"%d",	SaveCloclk );
	
	return TRUE;
}


////////////////////////////////////////////////////////////////
// ɤǤLOAD
//
// :	Ini		INI֥ȥݥ
// :	BOOL	TRUE: FALSE:
////////////////////////////////////////////////////////////////
BOOL SCH6::DokoLoad( cIni *Ini )
{
	if( !Ini ) return FALSE;
	
	// ƤΥ٥ȤҤȤޤ̵ˤ
	// ٥Ⱦϳƥ⥸塼˺ꤹ
	for( int i=0; i<MAXEVENT; i++ ){
		ev[i].device = NULL;
		ev[i].Active = FALSE;
	}
	
	Ini->GetInt(    "SCHEDULE", "MasterClock",	&MasterClock,	MasterClock );
	Ini->GetInt(    "SCHEDULE", "CpuClock",		&CpuClock,		CpuClock );
	Ini->GetTruth(  "SCHEDULE", "VSYNC",		&VSYNC, 		VSYNC );
	Ini->GetInt(    "SCHEDULE", "NextEvent",	&NextEvent,		NextEvent );	// ٥Ⱥ˺Ƹ?
	Ini->GetInt(    "SCHEDULE", "SaveCloclk",	&SaveCloclk,	SaveCloclk );
	
	return TRUE;
}
